# encoding: utf-8
module Git
  class Command
    def self.diff_tree(new)
      runner = Runner.new("git diff-tree -r --root #{new}")
      runner.result
    end

    def self.diff(old, new)
      runner = Runner.new("git diff --raw #{old} #{new}")
      runner.result
    end

    def self.init(path)
      runner = Git::Runner.new("git init #{path}")
      runner.result
    end

    def self.add(object)
      runner = Git::Runner.new("git add #{object}")
      runner.result
    end

    def self.status
      runner = Git::Runner.new('git status')
      runner.result
    end

    def self.commit(message)
      runner = Git::Runner.new("git commit -m \"#{message}\"")
      runner.result
    end

    def self.rm_r(file)
      runner = Git::Runner.new("git rm -r \"#{file}\"")
      runner.result
    end

    def self.show(sha = nil)
      cmd = ['git show']
      cmd << " #{sha}" if sha

      runner = Git::Runner.new(cmd.join(" "))
      runner.result
    end
  end
end
