# encoding: utf-8
module Git
  class PreReceiveHookParser
    private

    attr_reader :old_sha1, :new_sha1, :ref_name

    public

    def initialize(input)
      @old_sha1, @new_sha1, @ref_name = input.split(" ")
    end

    def files
      if old_sha1 == '0' * 40
        result = Git::Command.diff_tree(new_sha1)
        result.delete_at(0)
        result.delete_if { |l| l['0000000... D'] != nil }.collect { |l| File.new(l) }
      else
        result = Git::Command.diff(old_sha1, new_sha1)
        result.delete_if { |l| l['0000000... D'] != nil }.collect { |l| File.new(l) }
      end
    end
  end
end
